﻿@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

<div id="example-table"></div>

@*<div class="ui-panel-content ui-widget-content">
    <div class="ui-panel ui-widget ui-widget-content ui-corner-all box-primary">
        <table id="tblExtracto">
            <thead>
            <tr>
                <th>Id</th>
                <th>Descripcion</th>
                <th>Nro Orden</th>
                <th>Nro Orden Paga</th>
                <th>Fecha</th>
            </tr>
            </thead>
            @foreach (var item in Model.boletas)
            {
                <tr>
                    <td>@item.Id</td>
                    <td>@item.Descripcion</td>
                    <td>@item.NumOrden</td>
                    <td>@item.NumOrdenPaga</td>
                    <td>@item.Fecha</td>
                </tr>
            }
            <tbody></tbody>
        </table>
    </div>
    <div>
        @if (Model.boletas.Any())
        {
            <button id="btn" class="btn btn-primary">Imprimir</button>
        }
    </div>
</div>*@

<div id="tableHijos"></div>


<button id='toggle1' class="btn btn-primary">Toggle Sub Table 1</button>
<button id='toggle2' class="btn btn-primary">Toggle Sub Table 2</button>
<div id="nestedTables"></div>


@section Scripts
{
    <script>
    // var myJSON = JSON.stringify(data);
    
    var arr = JSON.parse('@Html.Raw(Json.Serialize(@Model.boletas))')   //Serializando la DTO lee 2 veces
    //Mejor SERIALIZARLO EN JSON desde el C# y aqui solo hacer el PARSE
    var arr1 = JSON.parse('@Html.Raw(@Model.dataJson)')

    // console.log(arr);
    console.log("-------------------------------");
    console.log(arr1);
    
    //Probando funcionalidad de los Botones y el Formater
    var previsualizarFormIcon = function(cell, formatterParams){
            var data = cell.getData();
            return "<button class='btn btn-info'><i class='fa fa-eye'></i> Ver</button>";
    };
    var certificacionFormIcon = function(cell, formatterParams){
            var data = cell.getData();
            return "<button type='button' class='btn btn-primary'><i class='fa fa-award'></i> Certificar</button>";
    };
    var plusIcon = function (cell,formatterParams){
        var data = cell.getData();
        return "<button type='button' class='btn btn-primary'>+</button>";
    };

    
    //Data del EJEMPLO - 1
    var tableDataNested = [
            {name:"Oli Bob", location:"United Kingdom", gender:"male", col:"red", dob:"14/04/1984", _children:[
                {name:"Mary May", location:"Germany", gender:"female", col:"blue", dob:"14/05/1982"},
                {name:"Christine Lobowski", location:"France", gender:"female", col:"green", dob:"22/05/1982"},
                {name:"Brendon Philips", location:"USA", gender:"male", col:"orange", dob:"01/08/1980", _children:[
                    {name:"Margret Marmajuke", location:"Canada", gender:"female", col:"yellow", dob:"31/01/1999"},
                    {name:"Frank Harbours", location:"Russia", gender:"male", col:"red", dob:"12/05/1966"},
                ]},
            ]},
            {name:"Jamie Newhart", location:"India", gender:"male", col:"green", dob:"14/05/1985"},
            {name:"Gemma Jane", location:"China", gender:"female", col:"red", dob:"22/05/1982", _children:[
                {name:"Emily Sykes", location:"South Korea", gender:"female", col:"maroon", dob:"11/11/1970"},
            ]},
            {name:"James Newman", location:"Japan", gender:"male", col:"red", dob:"22/03/1998"},
        ];
    //Mi DTO en JSON, para pruebas
    var dataBoleta = [{"Id":0,"Descripcion":"Padre","NumOrden":0,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1156799-04:00","_children":[{"Id":0,"Descripcion":"Hijos","NumOrden":0,"NumOrdenPaga":2,"Fecha":"2021-10-21T11:35:04.1152694-04:00"},{"Id":1,"Descripcion":"Hijos","NumOrden":2,"NumOrdenPaga":3,"Fecha":"2021-10-21T11:35:04.1153471-04:00"}]},{"Id":1,"Descripcion":"Padre","NumOrden":2,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158221-04:00","_children":null},{"Id":2,"Descripcion":"Padre","NumOrden":4,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158227-04:00","_children":[{"Id":0,"Descripcion":"Hijos","NumOrden":0,"NumOrdenPaga":2,"Fecha":"2021-10-21T11:35:04.1152694-04:00"},{"Id":1,"Descripcion":"Hijos","NumOrden":2,"NumOrdenPaga":3,"Fecha":"2021-10-21T11:35:04.1153471-04:00"}]},{"Id":3,"Descripcion":"Padre","NumOrden":6,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158228-04:00","_children":null},{"Id":4,"Descripcion":"Padre","NumOrden":8,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158229-04:00","_children":[{"Id":0,"Descripcion":"Hijos","NumOrden":0,"NumOrdenPaga":2,"Fecha":"2021-10-21T11:35:04.1152694-04:00"},{"Id":1,"Descripcion":"Hijos","NumOrden":2,"NumOrdenPaga":3,"Fecha":"2021-10-21T11:35:04.1153471-04:00"}]},{"Id":5,"Descripcion":"Padre","NumOrden":10,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158234-04:00","_children":null},{"Id":6,"Descripcion":"Padre","NumOrden":12,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158235-04:00","_children":[{"Id":0,"Descripcion":"Hijos","NumOrden":0,"NumOrdenPaga":2,"Fecha":"2021-10-21T11:35:04.1152694-04:00"},{"Id":1,"Descripcion":"Hijos","NumOrden":2,"NumOrdenPaga":3,"Fecha":"2021-10-21T11:35:04.1153471-04:00"}]},{"Id":7,"Descripcion":"Padre","NumOrden":14,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158245-04:00","_children":null},{"Id":8,"Descripcion":"Padre","NumOrden":16,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158247-04:00","_children":[{"Id":0,"Descripcion":"Hijos","NumOrden":0,"NumOrdenPaga":2,"Fecha":"2021-10-21T11:35:04.1152694-04:00"},{"Id":1,"Descripcion":"Hijos","NumOrden":2,"NumOrdenPaga":3,"Fecha":"2021-10-21T11:35:04.1153471-04:00"}]},{"Id":9,"Descripcion":"Padre","NumOrden":18,"NumOrdenPaga":0,"Fecha":"2021-10-21T11:35:04.1158249-04:00","_children":null}];
    
    //Data Nested Table
    var nestedData = [
        {id:1, make:"Ford", model:"focus", reg:"P232 NJP", color:"white", serviceHistory:[
           {date:"01/02/2016", engineer:"Steve Boberson", actions:"Changed oli filter"},
           {date:"07/02/2017", engineer:"Martin Stevenson", actions:"Break light broken"},
        ]},
        {id:2, make:"BMW", model:"m3", reg:"W342 SEF", color:"red", serviceHistory:[
           {date:"22/05/2017", engineer:"Jimmy Brown", actions:"Aligned wheels", date1:"22/05/2017", engineer1:"Jimmy Brown", actions1:"Aligned wheels"},
           {date:"11/02/2018", engineer:"Lotty Ferberson", actions:"Changed Oil", date1:"22/05/2017", engineer1:"Jimmy Brown", actions1:"Aligned wheels"},
           {date:"04/04/2018", engineer:"Franco Martinez", actions:"Fixed Tracking", date1:"22/05/2017", engineer1:"Jimmy Brown", actions1:"Aligned wheels"},
        ]},
        {id:3, make:"Toyota", model:"m3", reg:"Hilux", color:"red", serviceHistory:[
                   {date:"22/05/2017", engineer:"Jimmy Brown", actions:"Aligned wheels"},
                   {date:"11/02/2018", engineer:"Lotty Ferberson", actions:"Changed Oil"},
                   {date:"04/04/2018", engineer:"Franco Martinez", actions:"Fixed Tracking"},
        ]},
        {id:4, make:"Nissan", model:"m3", reg:"Frontier", color:"red", serviceHistory:[
                   {date:"22/05/2017", engineer:"Jimmy Brown", actions:"Aligned wheels"},
                   {date:"11/02/2018", engineer:"Lotty Ferberson", actions:"Changed Oil"},
                   {date:"04/04/2018", engineer:"Franco Martinez", actions:"Fixed Tracking"},
        ]},
        {id:5, make:"Susuki", model:"focus", reg:"Vitara", color:"white", serviceHistory:[
                   {date:"01/02/2016", engineer:"Steve Boberson", actions:"Changed oli filter"},
                   {date:"07/02/2017", engineer:"Martin Stevenson", actions:"Break light broken"},
        ]},
    ];
    //Tabla de EJEMPLO - 1
    var table = new Tabulator("#example-table", {
        height:"311px",
        data:tableDataNested,
        dataTree:true,
        dataTreeStartExpanded:false,
        columns:[
        {title:"Name", field:"name", width:200, responsive:0}, //never hide this column
        {title:"Location", field:"location", width:150},
        {title:"Gender", field:"gender", width:150, responsive:2}, //hide this column first
        {title:"Favourite Color", field:"col", width:150},
        {title:"Date Of Birth", field:"dob", hozAlign:"center", sorter:"date", width:150},
        ],
    });
    
    //Con esto trate de mostrar la tabla con HIJOS atraves de lOS OBJETOS DTO, pero no funciono
    
    /*var tableTest = new Tabulator("#tblExtracto", {
            height:"311px",
            
            dataTree:true,
            dataTreeStartExpanded:false,
            
            columns:[
            {title:"Id", field:"Id", width:200, responsive:0}, //never hide this column
            {title:"Descripcion", field:"Descripcion", width:150},
            {title:"Nro Orden", field:"NumOrden", width:150, responsive:2}, //hide this column first
            {title:"Nro Orden Paga", field:"NumOrdenPaga", width:150},
            {title:"Fecha", field:"Fecha", hozAlign:"center", sorter:"date", width:150, },
            ],
        });*/
    
    //Tabla EJEMPLO - 2, simulando lo de las boletas
    var tableTest = new Tabulator("#tableHijos", {
                height:"311px",
                data:arr1,  //La DATA de la tabla
                
                //Paginacion------Init
                pagination:"local",
                paginationSize:15,
                paginationSizeSelector:[5, 10, 15],
                reactiveData:true,  //Paginacion ----End
                
                //Para que funcionen los hijos
                dataTree:true,
                dataTreeStartExpanded:false,
                
                columns:[
                {title:"Id", field:"Id", width:200, responsive:0}, //never hide this column
                {title:"Descripcion", field:"Descripcion", width:150},
                {title:"Nro Orden", field:"NumOrden", width:150, responsive:2}, //hide this column first
                {title:"Nro Orden Paga", field:"NumOrdenPaga", width:150},
                {title:"Fecha", field:"Fecha", hozAlign:"center", sorter:"date", width:150},
                {
                        title: "ACCIÓNES",
                        field: "accion",
                        align: "center",
                        columns:[
                              {formatter:previsualizarFormIcon,title:"Previsualizar",align:"center",
                                   cellClick:function (e,cell){
                                   var data = cell.getData();
                                   console.log(data);
                              }},
                              {formatter:certificacionFormIcon,title:"Certificación", align:"center", 
                                   cellClick:function(e, cell){
                                   var data = cell.getData();
                                   console.log(data);
                              }},
                              ]
                        },
                ],
            });
   
    //Tabla EJEMPLO - 3, probando las tablas anidadas
    var Nestedtable = new Tabulator("#nestedTables", {
        // height:"311px",
                
        layout:"fitColumns",
        resizableColumns:false,
        data:nestedData,
        // rowClick: function(e, row) {
        //     const id = row.getData().id;
        //     console.log(id);
        //     $(".subTable" + id + "").toggle();
        //
        // },
          
        columns:[
            {formatter:plusIcon,title:"T",align:"center", width:"5px",
                   cellClick:function (e,cell){
                   var data = cell.getData();
                   console.log(data);                                                                          
            }},
            {title:"Make", field:"make"},
            {title:"Model", field:"model"},
            {title:"Registration", field:"reg"},
            {title:"Color", field:"color"},
        ],
        // rowFormatter:function(row){
        //     var data = cell.getData();
        //     console.log(data);
        //     //create and style holder elements
        //    var holderEl = document.createElement("div");
        //    var tableEl = document.createElement("div");
        //
        //    holderEl.style.boxSizing = "border-box";
        //    holderEl.style.padding = "10px 30px 10px 10px";
        //    holderEl.style.borderTop = "1px solid #333";
        //    holderEl.style.borderBotom = "1px solid #333";
        //    holderEl.style.background = "#ddd";
        //    holderEl.setAttribute('class', 'subTable1');
        //
        //    tableEl.style.border = "1px solid #333";
        //    tableEl.setAttribute('class', 'subTable2');
        //
        //    holderEl.appendChild(tableEl);
        //
        //    row.getElement().appendChild(holderEl);
        //
        //    var subTable = new Tabulator(tableEl, {
        //        layout:"fitColumns",
        //        data:row.getData().serviceHistory,
        //        columns:[
        //        {title:"Date", field:"date", sorter:"date"},
        //        {title:"Engineer", field:"engineer"},
        //        {title:"Action", field:"actions"},
        //        {title:"Date", field:"date1", sorter:"date"},
        //        {title:"Engineer", field:"engineer1"},
        //        {title:"Action", field:"actions1"},
        //        ]
        //    })
        // },
    });
        
    $("#toggle1").click(function() {
      $(".subTable1").toggle();
    });
    
    $("#toggle2").click(function() {
      $(".subTable2").toggle();
    });
    </script>
}
